#include <MegunoLink.h>
#include <CommandHandler.h>
#include <ArduinoTimer.h>

CommandHandler<10,100,1> CmdHandler; //expand the command handler to accept messages 100 characters
InterfacePanel MyPanel;
ArduinoTimer RequestTimer;

int Values[20];

// Once the SendValues command is called a packet is assembled at the computer end
// and sent out with 20 values in it.
void Cmd_IncomingValues(CommandParameter &Parameters)
{
  for (int i = 0; i < 20; i++)
  {
    Values[i] = Parameters.NextParameterAsInteger();
  }

  int i = 0;
  MyPanel.SetNumber(F("IPNumericUpDown1"), Values[i]+1); i++;
  MyPanel.SetNumber(F("IPNumericUpDown2"), Values[i]+1); i++;
  MyPanel.SetNumber(F("IPNumericUpDown3"), Values[i]+1); i++;
  MyPanel.SetNumber(F("IPNumericUpDown4"), Values[i]+1); i++;
  MyPanel.SetNumber(F("IPNumericUpDown5"), Values[i]+1); i++;
  MyPanel.SetNumber(F("IPNumericUpDown6"), Values[i]+1); i++;
  MyPanel.SetNumber(F("IPNumericUpDown7"), Values[i]+1); i++;
  MyPanel.SetNumber(F("IPNumericUpDown8"), Values[i]+1); i++;
  MyPanel.SetNumber(F("IPNumericUpDown9"), Values[i]+1); i++;
  MyPanel.SetNumber(F("IPNumericUpDown10"), Values[i]+1); i++;
  MyPanel.SetNumber(F("IPNumericUpDown11"), Values[i]+1); i++;
  MyPanel.SetNumber(F("IPNumericUpDown12"), Values[i]+1); i++;
  MyPanel.SetNumber(F("IPNumericUpDown13"), Values[i]+1); i++;
  MyPanel.SetNumber(F("IPNumericUpDown14"), Values[i]+1); i++;
  MyPanel.SetNumber(F("IPNumericUpDown15"), Values[i]+1); i++;
  MyPanel.SetNumber(F("IPNumericUpDown16"), Values[i]+1); i++;
  MyPanel.SetNumber(F("IPNumericUpDown17"), Values[i]+1); i++;
  MyPanel.SetNumber(F("IPNumericUpDown18"), Values[i]+1); i++;
  MyPanel.SetNumber(F("IPNumericUpDown19"), Values[i]+1); i++;
  MyPanel.SetNumber(F("IPNumericUpDown20"), Values[i]+1); i++;
}

// The setup() function runs once each time the micro-controller starts
void setup()
{
  Serial.begin(9600);
  CmdHandler.AddCommand(F("SV"), Cmd_IncomingValues);
}

// Add the main program code into the continuous loop() function
void loop()
{
  CmdHandler.Process();
  if (RequestTimer.TimePassed_Milliseconds(2000))
  {
    MyPanel.CallCommand(F("SendValues")); //this triggers the SendValues command in the message library
  }
}
